/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.sapics.client.gui;

import java.awt.BorderLayout;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.sapics.client.eof.model.EOIndividu;
import org.cocktail.sapics.client.eof.model.EOLotUtilisateur;
import org.cocktail.sapics.client.eof.model.EOUtilisateur;
import org.cocktail.sapics.client.swing.TableSorter;
import org.cocktail.sapics.client.swing.ZEOTable;
import org.cocktail.sapics.client.swing.ZEOTableModel;
import org.cocktail.sapics.client.swing.ZEOTableModelColumn;
import org.cocktail.sapics.client.utilities.CocktailConstantes;

import com.webobjects.eointerface.EODisplayGroup;

/**
 *
 * @author  cpinsard
 */
public class LotUtilisateursView extends javax.swing.JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = -2627576813623940082L;

	protected EODisplayGroup eodUtilisateur;

	protected ZEOTable myEOTableUtilisateur;
	protected ZEOTableModel myTableModelUtilisateur ;
	protected TableSorter myTableSorterUtilisateur;

	/** Creates new form TemplateJPanel */
	public LotUtilisateursView(EODisplayGroup dgUtilisateurs) {

		eodUtilisateur = dgUtilisateurs;

		initComponents();
		initGui();

	}


	/** This method is called from within the constructor to
	 * initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is
	 * always regenerated by the Form Editor.
	 */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        viewTableUtilisateurs = new javax.swing.JPanel();
        btnAddUtilisateur = new javax.swing.JButton();
        btnDelUtilisateur = new javax.swing.JButton();

        viewTableUtilisateurs.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        viewTableUtilisateurs.setLayout(new java.awt.BorderLayout());

        btnAddUtilisateur.setToolTipText("Ajout d'un nouvel utilisateur");

        btnDelUtilisateur.setToolTipText("Suppression de l'utilisateur sélectionné");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .add(143, 143, 143)
                .add(viewTableUtilisateurs, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 594, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, btnDelUtilisateur, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, btnAddUtilisateur, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(124, 124, 124))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(viewTableUtilisateurs, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 144, Short.MAX_VALUE)
                    .add(layout.createSequentialGroup()
                        .add(btnAddUtilisateur, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnDelUtilisateur, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .add(34, 34, 34))
        );
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddUtilisateur;
    private javax.swing.JButton btnDelUtilisateur;
    protected javax.swing.JPanel viewTableUtilisateurs;
    // End of variables declaration//GEN-END:variables




	private void initGui() {

		btnAddUtilisateur.setIcon(CocktailConstantes.ICON_ADD);
		btnDelUtilisateur.setIcon(CocktailConstantes.ICON_DELETE);

		Vector<ZEOTableModelColumn> myCols = new Vector<ZEOTableModelColumn>();

		ZEOTableModelColumn col = new ZEOTableModelColumn(eodUtilisateur, EOLotUtilisateur.UTILISATEUR_KEY+"."+
				EOUtilisateur.INDIVIDU_KEY+"."+EOIndividu.NOM_USUEL_KEY, "Nom", 150);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodUtilisateur, EOLotUtilisateur.UTILISATEUR_KEY+"."+
				EOUtilisateur.INDIVIDU_KEY+"."+EOIndividu.PRENOM_KEY, "Prénom", 150);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);

		myTableModelUtilisateur = new ZEOTableModel(eodUtilisateur, myCols);
		myTableSorterUtilisateur = new TableSorter(myTableModelUtilisateur);

		myEOTableUtilisateur = new ZEOTable(myTableSorterUtilisateur);
		//myEOTableNuits.addListener(myListenerContrat);
		myTableSorterUtilisateur.setTableHeader(myEOTableUtilisateur.getTableHeader());		

		myEOTableUtilisateur.setBackground(CocktailConstantes.COLOR_BKG_TABLE_VIEW);
		myEOTableUtilisateur.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTableUtilisateur.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);

		viewTableUtilisateurs.setLayout(new BorderLayout());
		viewTableUtilisateurs.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableUtilisateurs.removeAll();
		viewTableUtilisateurs.add(new JScrollPane(myEOTableUtilisateur), BorderLayout.CENTER);

	}


	public ZEOTable getMyEOTableUtilisateur() {
		return myEOTableUtilisateur;
	}


	public void setMyEOTableUtilisateur(ZEOTable myEOTableUtilisateur) {
		this.myEOTableUtilisateur = myEOTableUtilisateur;
	}


	public javax.swing.JButton getBtnAddUtilisateur() {
		return btnAddUtilisateur;
	}


	public void setBtnAddUtilisateur(javax.swing.JButton btnAddUtilisateur) {
		this.btnAddUtilisateur = btnAddUtilisateur;
	}


	public javax.swing.JButton getBtnDelUtilisateur() {
		return btnDelUtilisateur;
	}


	public void setBtnDelUtilisateur(javax.swing.JButton btnDelUtilisateur) {
		this.btnDelUtilisateur = btnDelUtilisateur;
	}

}

